# -*- coding: utf-8 -*-
import xbmc, xbmcgui, xbmcplugin, xbmcaddon, xbmcvfs, os, sys, time
import pztv

if sys.version_info.major > 2:  # Python 3 or later
	import urllib.request
	from urllib.parse import quote
	from urllib.parse import unquote
	import urllib.request as urllib2
	from urllib.parse import urlencode
else:  # Python 2
	import urllib, urlparse
	from urllib import quote
	from urllib import unquote_plus as unquote
	import urllib2
	from urllib import urlencode

def xt(x):
	try: r = xbmc.translatePath(x)
	except: r = xbmcvfs.translatePath(x)
	return r


PLUGIN_NAME   = 'plugin.video.pazl3.tv'
#handle = int(sys.argv[1])
addon = xbmcaddon.Addon(id=PLUGIN_NAME)
__settings__ = xbmcaddon.Addon(id=PLUGIN_NAME)
pztv.__settings__=__settings__
icon = xt(os.path.join(addon.getAddonInfo('path'), 'icon.png'))
background = xt(os.path.join(addon.getAddonInfo('path'), 'fanart.png'))

#from DBcnl import *

def log(text, x3=''):
	print (text)

#Action Codes
# See guilib/Key.h
ACTION_CANCEL_DIALOG = (9,10,51,92,110)
ACTION_PLAYFULLSCREEN = (12,79,227)
ACTION_MOVEMENT_LEFT = (1,)
ACTION_MOVEMENT_RIGHT = (2,)
ACTION_MOVEMENT_UP = (3,)
ACTION_MOVEMENT_DOWN = (4,)
ACTION_MOVEMENT = (1, 2, 3, 4, 5, 6, 159, 160)
ACTION_INFO = (11,)
ACTION_CONTEXT = (117,)
ACTION_MOVEMENT_ALL = (1, 2, 3, 4, 5, 6, 159, 160, 104, 105, 106, 107)


#ControlIds
CONTROL_CONSOLES = 500
CONTROL_GENRE = 600
CONTROL_YEAR = 700
CONTROL_PUBLISHER = 800
CONTROL_CHARACTER = 900
FILTER_CONTROLS = (500, 600, 700, 800, 900,)
GAME_LISTS = (50, 51, 52,53, 54, 55, 56, 57, 58)
CONTROL_SCROLLBARS = (2200, 2201, 60, 61, 62)

CONTROL_GAMES_GROUP_START = 600
CONTROL_GAMES_GROUP_END = 59

#CONTROL_BUTTON_CHANGE_VIEW = 2
CONTROL_BUTTON_FAVORITE = 1000
CONTROL_BUTTON_SEARCH = 1100
CONTROL_BUTTON_VIDEOFULLSCREEN = (2900, 2901,)
NON_EXIT_RCB_CONTROLS = (500, 600, 700, 800, 900, 2, 1000, 1100)

CONTROL_LABEL_MSG = 4000
CONTROL_BUTTON_MISSINGINFODIALOG = 4001

D_inf={}

from threading import Thread
class MyThread(Thread):
	def __init__(self, param):
		Thread.__init__(self)
		self.param = param
	
	def run(self):
		obj=self.param['obj']
		obj.epg_loop()


def create_thread(param):
		my_thread = MyThread(param)
		my_thread.start()

class MyThread2(Thread):
	def __init__(self, param):
		Thread.__init__(self)
		self.param = param
	
	def run(self):
		if self.param=='EPG': update_current_epg2()
		if self.param=='Arhive': update_Arhive2()
		if self.param=='Channel': update_cnldb()


def create_thread_upepg():
		my_thread = MyThread2('EPG')
		my_thread.start()

def create_thread_uparh():
		my_thread = MyThread2('Arhive')
		my_thread.start()

def create_thread_upcnl():
		my_thread = MyThread2('Channel')
		my_thread.start()


def b2s(s):
	if sys.version_info.major > 2:
		try:s=s.decode('utf-8')
		except: pass
		try:s=s.decode('windows-1251')
		except: pass
		try:s=s.decode('cp437')
		except: pass
		return s
	else:
		return s

def eval_u(inf):
	#print (inf)
	if sys.version_info.major > 2: 
		inf2 = 'b'+repr(inf).replace("\\\\x", "\\x")
		#print (inf2)
		info = eval(eval(inf2))##.replace("\\x", "\\\\x").replace("\\r", "\\\\r").replace("\\n", "\\\\n")
		#print (info)
	else:
		info = eval(inf)
	return info


def get_inf_cnl(id):
	if id in D_inf.keys(): return D_inf[id]
	inf = eval_u(pztv.SEND('/channel/'+id+'/inf'))
	D_inf[id]=inf
	return inf


def update_list_epg():
	update_current_epg()
	#try: Lepg=eval(pztv.getURL('http://127.0.0.1:'+epg_port+'/channels/all'))
	#except: Lepg=[]
	
	if r>=0:
		Player.stop()
		xbmc.sleep(500)
		Player.play(playlist, windowed=True, startpos=r)

Arhive=[]
def update_Arhive2():
	global Arhive
	try: Arhive=pztv.get_arhive_list()
	except: Arhive=[]

def update_Arhive():
	create_thread_uparh()

def update_cnldb():
	GL = pztv.open_Groups()
	#pDialog = xbmcgui.DialogProgressBG()
	#pDialog.create('Пазл ТВ', 'Загрузка каналов')
	n=0
	pztv.root(__settings__.getSetting("Sel_gr"))
	for i in GL:
		n+=1
		xbmc.sleep(100)
		pztv.root(i[0])
		#pDialog.update(int((n) * 100/ len(GL)))
	#pDialog.close()


last_epg_up = 0
current_epg={}
Lepg=[]
def update_current_epg2():
	global current_epg
	global Lepg
	global last_epg_up
	try:
		if time.time()-last_epg_up<30: return
	except: pass
	if __settings__.getSetting("epgon")=='true':
		try:
			if __settings__.getSetting("part")=='true':
					p_epg = None
					for p in range (1, 30):
						current_epg_p=eval_u(pztv.SEND('epg/current/p='+str(p)))
						if p_epg == current_epg_p: break
						else: p_epg = current_epg_p
						for k in current_epg_p.keys():
							current_epg[k]=current_epg_p[k]
			else:
					current_epg=eval_u(pztv.SEND('epg/current'))
				
			Lepg=current_epg.keys()
		except:
			try:
				if current_epg == None: 
					current_epg={}
					Lepg=[]
			except:
				current_epg={}
				Lepg=[]
	else:
			current_epg={}
			Lepg=[]
	last_epg_up = time.time()

def update_current_epg():
	create_thread_upepg()

#update_list_epg()
if 'keenetic' in __settings__.getSetting("serv_adr"): create_thread_upcnl()
update_Arhive()
update_current_epg()

def get_time():
	try:
		tm = xbmc.Player().getTime()
		if tm < 0 or tm == None: tm = 0
	except:
		tm = 0
	return tm

def wait_play(t=0):
		if t == 0: 
			try: t = (int(__settings__.getSetting("to_play"))+1)*5
			except: t = 10
		for i in range(t*2):
			if  xbmc.Player().isPlaying()==True: break#get_time()>0 and
			time.sleep(0.5)


def get_type(title):
	if   'Х/ф ' in title: return 'фильмы'
	elif 'Новости' in title: return 'новости'
	elif 'Т/с ' in title: return 'сериалы'
	elif 'М/с ' in title: return 'детям'
	elif 'Клипы' in title: return 'музыка'
	elif 'Clips' in title: return 'музыка'
	elif 'Playlist' in title: return 'музыка'
	else: return ''

def get_type_art(type):
	film = xt(os.path.join(addon.getAddonInfo('path'),'images', 'film.jpg'))
	info = xt(os.path.join(addon.getAddonInfo('path'),'images', 'info.jpg'))
	life = xt(os.path.join(addon.getAddonInfo('path'),'images', 'life.jpg'))
	mult = xt(os.path.join(addon.getAddonInfo('path'),'images', 'mult.jpg'))
	news = xt(os.path.join(addon.getAddonInfo('path'),'images', 'news.jpg'))
	show = xt(os.path.join(addon.getAddonInfo('path'),'images', 'show.jpg'))
	sport = xt(os.path.join(addon.getAddonInfo('path'),'images', 'sport.jpg'))
	science = xt(os.path.join(addon.getAddonInfo('path'),'images', 'science.jpg'))
	music = xt(os.path.join(addon.getAddonInfo('path'),'images', 'music.jpg'))
	
	if   type=='фильмы' or type=="movie":  return film
	elif type=='инфо'  or type=="info":    return info
	elif type=='досуг' or type=='live':    return life
	elif type=='детям':                    return mult
	elif type=='новости':                  return news
	elif type=='познавательное':           return science
	elif type=='сериалы' or type=='tvshow': return show
	elif type=='sport'   or type=='спорт' : return sport
	elif type=='музыка'                   : return music
	else: return background



class VFS_XML(xbmcgui.WindowXML):
	def __init__(self,strXMLname, strFallbackPath, strDefaultName, forceFallback):
		#xbmcplugin.endOfDirectory(handle, False, False)
		self.uptime=0
		self.info_visible=True
		self.exit=False
		#self.time_visible=time.time()
		self.progress_bar = xbmcgui.DialogProgress()

	def onInit(self):
		v_id    =__settings__.getSetting("v_id")
		last_id =__settings__.getSetting("cplayed")
		if v_id!=last_id: xbmc.Player().stop()
		#self.tugle_info_visible(True)
		try:n_play=int(__settings__.getSetting("n_play"))
		except:n_play=0
		
		if v_id == '': 
			if __settings__.getSetting("autoskip") == 'true':
					if 0<n_play<6:
						dr = __settings__.getSetting("lastnx")
						if dr=='>': self.Next(n_play+1)
						else:       self.Prev(n_play+1)
						#__settings__.setSetting("n_play",str(n_play+1))
					elif n_play>5: 
						self.exit=True
						self.close()
					elif n_play==0: 
						self.exit=True
						self.close()
			else:
				self.exit=True
				self.close()
			return
		else:
			__settings__.setSetting("n_play", '0')
		
		if xbmc.Player().isPlaying()==False: self.run_starter()#get_time()<1
		
		if xbmc.Player().isPlaying()==False:
			self.exit=True
			self.close()
			return
		#self.tugle_info_visible(False)
		#if xbmc.Player().isPlaying()==True: 
		self.setEPG(True)
		wait_play()
		self.tugle_info_visible('flap')
		'''
		#self.setFocus(self.getControl(1))
		if xbmc.Player().isPlaying():
			if last_id != v_id: pztv.play(v_id)
		else: 
								pztv.play(v_id)
		#pztv.set_np ()
		'''
		
		'''
		time.sleep(1)
		playlist = pztv.playlist
		if playlist.size()==0: 
			time.sleep(3)
		else: 
			wait_play()
			#for i in range(20):
			#	if get_time()>0: break
			#	time.sleep(0.5)
		
		self.loop()
		'''
		#self.tugle_info_visible(True)
		#time.sleep(5)
		

	def loop_off(self, pos=0):
		self.progress_bar.create('ПАЗЛ ТВ', '')
		#pztv.set_np ()
		#try: PlayingFile=xbmc.Player().getPlayingFile()
		#except: PlayingFile=''
		
		#while True:
		if self.progress_bar.iscanceled(): 
					self.progress_bar.close()
					self.exit=True
					self.close()
					return
		
		#if PlayingFile=='':
		
		if get_time()==0:
			playlist = pztv.playlist #xbmc.PlayList (xbmc.PLAYLIST_VIDEO)
			position = playlist.getposition()
			if position < 0: position = pos
			if position < playlist.size()-1:
				try: self.progress_bar.update(int((position+1) * 100/ playlist.size() ),'> > >','Потоков: '+str(playlist.size()),'Запускаемый: '+str(position+2) )
				except: self.progress_bar.update(int((position+1) * 100/ playlist.size() ),'> > >\nПотоков: '+str(playlist.size())+'\nЗапускаемый: '+str(position+2) )
				xbmc.Player().play(playlist, windowed=True, startpos=position+1)
				try: top = (int(__settings__.getSetting("to_play"))+1)*5
				except: top = 10
				for j in range(top):
					time.sleep(0.5)
					if get_time()>0: break
					if self.progress_bar.iscanceled(): 
						xbmc.Player().stop()
						self.progress_bar.close()
						self.exit=True
						self.close()
						return

				self.loop(pos=position+1)
			elif __settings__.getSetting("autoskip") == 'true':
		#if PlayingFile=='' and playlist.getposition() = playlist.size():
				#try:BanCashe.append(Lpurl2[0])
				#except: pass
				try:n_play=int(__settings__.getSetting("n_play"))
				except:n_play=0
				if n_play<3:
					try: self.progress_bar.update( (n_play+1)*30,'  >|  ','Нет потоков','Переход на другой канал')
					except: self.progress_bar.update( (n_play+1)*30,'  >|  \nНет потоков\n Переход на другой канал')
					if self.progress_bar.iscanceled(): 
						self.progress_bar.close()
						self.exit=True
						self.close()
						return
					__settings__.setSetting("n_play",str(n_play+1))
					#self.tugle_info_visible(True)
					pztv.next (__settings__.getSetting("lastnx"))
					
					if self.progress_bar.iscanceled():
						xbmc.Player().stop()
						self.progress_bar.close()
						self.exit=True
						self.close()
						return
					
					self.tugle_info_visible(True)
					self.loop()
				else:
					self.progress_bar.close()
					self.exit=True
					self.close()
		self.progress_bar.close()


	def onInit_old(self):
		self.tugle_info_visible(True)
		self.setFocus(self.getControl(1))
		#self.setEPG()
		if xbmc.Player().isPlaying():
			last_id =__settings__.getSetting("cplayed")
			v_id =__settings__.getSetting("v_id")
			if last_id != v_id: 
				#__settings__.setSetting("lastplayed", v_id)
				#xbmc.sleep(300)
				pztv.play(v_id)
		else:
			v_id =__settings__.getSetting("v_id")
			#__settings__.setSetting("lastplayed", v_id)
			#xbmc.sleep(300)
			pztv.play(v_id)
		
		self.tugle_info_visible(False)
		#self.doModal()
		#print xbmcgui.getCurrentWindowId()
		#while  xbmc.Player().isPlaying():
		#		xbmc.sleep(500)
		#		self.setEPG()
		while  xbmc.Player().isPlaying():
				xbmc.sleep(500)
				#self.show()
		#if not xbmc.Player().isPlaying():
		__settings__.setSetting("lastplayed", '')
		self.exit=True
		self.close()
	
	def onAction(self, action):
		#self.time_visible=time.time()
		log("onAction: "+ str(action.getId()))
		# Same as normal python Windows.
		if(action.getId() == 0):
			log("actionId == 0. Input ignored")
			return
		if(action.getId() in ACTION_CANCEL_DIALOG):
				log("onAction: ACTION_CANCEL_DIALOG")
					
				if self.selectedControlId in [7,8,9,10,11]: 
					#self.setFocus(self.getControl(1))
					self.tugle_info_visible(False)
				elif self.info_visible==False: 
					self.exit=True
					self.close()
		
		if action.getId() == 13 :
			pztv.Player_stop()
			self.exit=True
			self.close()
		
		if action.getId() == 11 :
			self.tugle_info_visible()
		
		if action.getId() in ACTION_MOVEMENT_UP: self.Next()
			
		if action.getId() in ACTION_MOVEMENT_DOWN: self.Prev()
			
		if action.getId() in ACTION_MOVEMENT_LEFT: 
			if self.info_visible==False: self.run_list()
				
		if action.getId() in ACTION_MOVEMENT_RIGHT: 
			if self.info_visible==False: self.run_list()
		
		
		self.setEPG()
			
			
	def onClick(self, controlID):
		print ('onClick ' +str(controlID))
		if controlID == 7 : self.run_arhive()
		if controlID == 8 : pztv.select_stream()
		if controlID == 11:
			pztv.Player_stop()
			self.exit=True
			self.close()
		if controlID == 10 : self.Next()
		if controlID == 9  : self.Prev()
		if controlID == 1  : self.tugle_info_visible(True)
		if controlID == 6  : self.tugle_info_visible(False)
		update_current_epg()
	
	def onFocus(self, controlID):
		self.selectedControlId = controlID

	def tugle_info_visible(self, vis=' '):
		if vis==True:
			self.uptime=0
			self.setEPG()
		win = xbmcgui.Window (xbmcgui.getCurrentWindowId())
		if vis==False:
			self.info_visible=False
			win.setProperty('info_visible',  '')
		elif vis==True:
			self.info_visible=True
			win.setProperty('info_visible',  'true')
		elif vis=='flap':
			win.setProperty('info_visible',  'true')
			self.info_visible=True
			time.sleep(2)
			win.setProperty('info_visible',  '')
			self.info_visible=False
		else:
			if self.info_visible==True:
				self.info_visible=False
				win.setProperty('info_visible',  '')
			else: 
				self.info_visible=True
				win.setProperty('info_visible',  'true')
			
		if self.info_visible==False: self.setFocus(self.getControl(1))
		if self.info_visible==True: self.setFocus(self.getControl(9))
		update_current_epg()
	
	def Next(self, n=1):
		#if xbmc.Player().isPlaying():
			__settings__.setSetting("n_play",str(n))
			v_id =__settings__.getSetting("next_itm")
			__settings__.setSetting("v_id", v_id)
			__settings__.setSetting("lastnx",">")
			#self.tugle_info_visible(True)
			
			
			self.run_starter()
			self.onInit()
			#if xbmc.Player().isPlaying()==True: self.tugle_info_visible('flap')
			#self.close()
			'''
			v_id=pztv.next ('>')
			#v_id =__settings__.getSetting("cplayed")
			#__settings__.setSetting("v_id", v_id)
			#self.tugle_info_visible(True)
			wait_play()
			#for i in range(20):
			#	if get_time()>0: break
			#	time.sleep(0.5)
			self.loop()
			for i in range (5):
				if not xbmc.Player().isPlaying():
					#xbmc.sleep(1000)
					time.sleep(3)
				if not xbmc.Player().isPlaying():
					#xbmc.sleep(1000)
					time.sleep(2)
				if not xbmc.Player().isPlaying():
					id =__settings__.getSetting("next_itm")
					__settings__.setSetting("v_id", id)
					self.tugle_info_visible(True)
					v_id=pztv.next ('>')
				'''
			#if self.selectedControlId not in [9,10,11]:
			#	time.sleep(1)
			#	self.tugle_info_visible(False)

	def Prev(self,n=1):
		#if xbmc.Player().isPlaying():
			#__settings__.setSetting("n_play","0")
			__settings__.setSetting("n_play",str(n))
			v_id =__settings__.getSetting("prev_itm")
			__settings__.setSetting("v_id", v_id)
			__settings__.setSetting("lastnx","<")
			#self.tugle_info_visible(True)
			#xbmc.Player().stop()
			
			self.run_starter()
			self.onInit()
			#if xbmc.Player().isPlaying()==True: self.tugle_info_visible('flap')
			#self.close()
			'''
			v_id=pztv.next ('<')
			#v_id =__settings__.getSetting("cplayed")
			#__settings__.setSetting("v_id", v_id)
			#self.tugle_info_visible(True)
			wait_play()
			#for i in range(20):
			#	if get_time()>0: break
			#	time.sleep(0.5)
			self.loop()
			
			for i in range (5):
				if not xbmc.Player().isPlaying():
					#xbmc.sleep(1000)
					time.sleep(3)
				if not xbmc.Player().isPlaying():
					#xbmc.sleep(1000)
					time.sleep(2)
				if not xbmc.Player().isPlaying():
					id =__settings__.getSetting("prev_itm")
					__settings__.setSetting("v_id", id)
					self.tugle_info_visible(True)
					v_id=pztv.next ('<')
			'''
			#if self.selectedControlId not in [9,10,11]:
			#	time.sleep(1)
			#	self.tugle_info_visible(False)


	def setEPG(self, up=False):
			try:
				delta=time.time()-self.uptime
				if delta > 45 or up:
					win = xbmcgui.Window (xbmcgui.getCurrentWindowId())
					id =__settings__.getSetting("v_id")
					inf = get_inf_cnl(id)#eval_u(pztv.SEND('/channel/'+id+'/inf'))
					cn_name  = inf['title']
					picon = inf['picon']
					#win.setProperty('picon',   picon)
					#win.setProperty('title',   cn_name)

					self.uptime=time.time()
					EPG=[]
					#if id in Lepg and __settings__.getSetting("epgon")=='true':
					try:
						if id in current_epg.keys(): EPG=current_epg[id]#eval(pztv.getURL(lnk))
					except: 
						print ('err current_epg '+id)

					if EPG!=[]:
							try:EPG0_time=time.ctime(eval(EPG[0]['time']))[-13:-8]
							except: EPG0_time=''
							try:EPG0_title=EPG[0]['title']
							except: EPG0_title=''
							try:EPG0_img=EPG[0]['img']
							except: EPG0_img=''#background
							try:EPG0_plot=EPG[0]['plot']
							except: EPG0_plot=''
								
							try:EPG1_time=time.ctime(eval(EPG[1]['time']))[-13:-8]
							except: EPG1_time=''
							try:EPG1_title=EPG[1]['title']
							except: EPG1_title=''
					else:
							EPG0_time=''
							EPG0_title=''
							EPG0_img=picon#background
							EPG0_img=''
							EPG0_plot=''
							EPG1_time=''
							EPG1_title=''
					
					if EPG0_time!='' and EPG1_time!='':
						t0=eval(EPG[0]['time'])
						t1=eval(EPG[1]['time'])
						tc=time.time()
						total=t1-t0
						back=tc-t0
						percent=int(back*100/total)
						if percent > 100: 
							percent=100
							update_current_epg()
					else:
						percent=0
					
					
					
					win.setProperty('EPG1_time',  EPG1_time)
					win.setProperty('EPG1_title', EPG1_title)
					win.setProperty('EPG0_time',  EPG0_time)
					win.setProperty('EPG0_img',   EPG0_img)
					win.setProperty('EPG0_title', EPG0_title)
					win.setProperty('EPG0_plot',  EPG0_plot)
					win.setProperty('picon',   picon)
					win.setProperty('title',   cn_name)
					
					bar=self.getControl(5)
					bar.setWidth(percent*5)
			except:
				print ('=========== set_epg ERRRRRRRRRRRRRRR ==========')
				pass
		
	def epg_loop(self, pos=0):
		if self.info_visible==True: self.setEPG()
		for i in range(3):
			if self.exit==True: return
			time.sleep(1)
		#print (pos)
		try: PlayingFile=xbmc.Player().getPlayingFile()
		except: PlayingFile=''
		#print (PlayingFile)
		#if '/udp/' in PlayingFile: 
		#	try:
				#response = urllib2.urlopen(PlayingFile, timeout=4)
				#r=response.getcode()
				#data=response.read(64)
				#response.close()
		#		print ((r,PlayingFile))
		#	except:
		#		print ('--- err upd link time ---')
		self.epg_loop(pos+1)
	
	
	def run_arhive(self):
				id =__settings__.getSetting("cplayed")
				if id in Arhive:
					__settings__.setSetting("arhive_cnl", id)
					__settings__.setSetting("arhive_cnl_id", id)
					arhive = ARHIVE_XML("PTV-arhive.xml", addon.getAddonInfo('path'), skin, "720p")
					xbmc.Player().stop()
					arhive.doModal()
					del arhive

	def run_list(self):
				#skin = "Default"
				lst = LIST_XML("PTV-list.xml", addon.getAddonInfo('path'), skin, "720p")
				#create_thread({'obj':lst})
				lst.doModal()
				del lst
				self.setEPG(True)

	def run_starter(self):
				self.exit=True
				if __settings__.getSetting("restreamer") == 'true':
					pztv.Player.play('http://roms.my1.ru/tv/term.mp4')
					xbmc.sleep(1000)
				else:
					xbmc.Player().stop()
				sts = STARTER_XML("PTV-starter.xml", addon.getAddonInfo('path'), skin, "720p")
				sts.doModal()
				#self.close()
				del sts
				self.setEPG(True)

class STARTER_XML(xbmcgui.WindowXMLDialog):#
	def __init__(self,strXMLname, strFallbackPath, strDefaultName, forceFallback):
		self.uptime=0
		self.info_visible=False
		self.exit=False
		self.progress_bar = xbmcgui.DialogProgress()
		id =__settings__.getSetting("v_id")
		inf = get_inf_cnl(id)#eval_u(pztv.SEND('/channel/'+id+'/inf'))
		self.cn_name  = inf['title']
		self.picon = inf['picon']

	def onInit(self):
		try:n_play=int(__settings__.getSetting("n_play"))
		except:n_play=0
		
		if xbmc.Player().isPlaying() or n_play>7:
			self.exit=True
			self.close()
		
		v_id    =__settings__.getSetting("v_id")
		last_id =__settings__.getSetting("cplayed")
		win = xbmcgui.Window (xbmcgui.getCurrentWindowDialogId())#
		win.setProperty('picon',   self.picon)
		win.setProperty('title',   self.cn_name)
		
		#time.sleep(1)
		playlist = pztv.play(v_id)#pztv.playlist
		try: playlist_size=playlist.size()
		except: playlist_size=0

		#if playlist.size()>0: wait_play()
		#time.sleep(1)
		#if playlist.size()>1 and xbmc.Player().isPlaying()==False: 
		if playlist_size>0:
			#pDialog = xbmcgui.DialogProgressBG()
			#pDialog.create(self.cn_name, 'Запуск: 1/'+str(playlist.size()))
			#time.sleep(0.1)
			#xbmc.Player().stop()
			self.loop(0, playlist)
			time.sleep(0.2)
			#pDialog.close()
		
		#if xbmc.Player().isPlaying()==False or get_time()<0: self.loop(1, playlist)
		
		if xbmc.Player().isPlaying()==False: 
			__settings__.setSetting("v_id",'')
		#	__settings__.setSetting("n_play",str(n_play+1))
		else:
			__settings__.setSetting("n_play",'1')

		self.exit=True
		self.close()
		#self.run_VFS()
	
	def loop(self, pos=0, playlist = pztv.playlist):
		pDialog = xbmcgui.DialogProgressBG()
		pDialog.create('', self.cn_name)

		#if self.progress_bar.iscanceled(): 
		#			self.progress_bar.close()
		#			self.exit=True
		#			self.close()
		#			return
		try: playlist_size=playlist.size()
		except: playlist_size=0
		#position = playlist.getposition()
		#if position < 0: position = pos
		for pos in range(playlist_size):
			if xbmc.Player().isPlaying()==False and playlist.size()>0:
				#position = playlist.getposition()
				#if position < 0: position = pos
				#if position < playlist_size:
					pztv.Player.play(playlist, windowed=True, startpos=pos)
					#if pos>0:
					#	self.progress_bar.create('ПАЗЛ ТВ', '')
					#	try: self.progress_bar.update(int((position+1) * 100/ playlist.size() ),'> > >','Поток: '+str(position+1)+' из '+str(playlist.size()) )
					#	except: self.progress_bar.update(int((position+1) * 100/ playlist.size() ),'> > >\nПоток: '+str(position+1)+' из '+str(playlist.size()) )
					
					try: top = (int(__settings__.getSetting("to_play"))+1)*5
					except: top = 10
					for j in range(top):
						pDialog.update(int(pos+1 * 100/ playlist_size ),'Запуск: '+str(pos+1)+'/'+str(playlist_size) )
						time.sleep(0.5)
						if xbmc.Player().isPlaying() :#and get_time()>0
							if pos>0:self.progress_bar.close()
							pDialog.close()
							return
						if pos==1: self.progress_bar.create('ПАЗЛ ТВ', '')
						if pos>0:
							try: self.progress_bar.update(int(pos+1 * 100/ playlist_size ),'> > >','Поток: '+str(pos+1)+' из '+str(playlist_size) )
							except: self.progress_bar.update(int(pos+1 * 100/ playlist_size ),'> > >\nПоток: '+str(pos+1)+' из '+str(playlist_size) )
							if self.progress_bar.iscanceled():
								xbmc.Player().stop()
								self.progress_bar.close()
								pDialog.close()
								self.exit=True
								self.close()
								return
						
					
					#position = playlist.getposition()
					#if pos<position: pos=position+1
		
		try:self.progress_bar.close()
		except: pass
		pDialog.close()
	
	def onAction(self, action):
		#self.time_visible=time.time()
		log("onAction: "+ str(action.getId()))
		# Same as normal python Windows.
		if(action.getId() == 0):
			log("actionId == 0. Input ignored")
			return
		if(action.getId() in ACTION_CANCEL_DIALOG):
				log("onAction: ACTION_CANCEL_DIALOG")
				self.exit=True
				self.close()
		
		if action.getId() == 13:
			xbmc.Player().stop()
			self.exit=True
			self.close()
	
	def onClick(self, controlID):
		if controlID == 11:
			xbmc.Player().stop()
			self.exit=True
			self.close()
	
	def onFocus(self, controlID):
		self.selectedControlId = controlID
	
	def run_list(self):
				#skin = "Default"
				lst = LIST_XML("PTV-list.xml", addon.getAddonInfo('path'), skin, "720p")
				lst.doModal()
				del lst

	def run_VFS(self):
			vfs = VFS_XML("PTV-VideoFullScreen.xml", addon.getAddonInfo('path'), skin, "720p")
			create_thread({'obj':vfs})
			vfs.doModal()
			del vfs
			self.close()

class UI_XML(xbmcgui.WindowXML):#Dialog
	selectedControlId = 0
	def __init__(self,strXMLname, strFallbackPath, strDefaultName, forceFallback):
		# Changing the three varibles passed won't change, anything
		# Doing strXMLname = "bah.xml" will not change anything.
		# don't put GUI sensitive stuff here (as the xml hasn't been read yet
		# Idea to initialize your variables here
		#xbmcplugin.endOfDirectory(handle, False, False)
		self.CurrentListPosition=0
		self.uptime=0
		self.uparh=0
		self.epg_exit=False
		self.wfs_visible=False
		#if __settings__.getSetting("arhon")=='true': update_Arhive()
		pass

	def onInit(self):
		try:
			# Put your List Populating code/ and GUI startup stuff here
			self.setFocus(self.getControl(CONTROL_GAMES_GROUP_START))
			#self.clearList()
			
			self.showList()
			
			abc=__settings__.getSetting("abc")
			btn=self.getControl(1)
			if abc == 'false':	btn.setLabel('Порядок: Свой')
			else:				btn.setLabel('Порядок: ABC')
			
			#if __settings__.getSetting("arhon")=='true' and self.uparh==0:
			#	update_Arhive()
			#	self.uparh=1
			#	self.setArhive()
		except:
			pass


	def onAction(self, action):
		log("onAction: "+ str(action.getId()))
		# Same as normal python Windows.
		if(action.getId() == 0):
			log("actionId == 0. Input ignored")
			return
		
		if(action.getId() in ACTION_CANCEL_DIALOG):
				log("onAction: ACTION_CANCEL_DIALOG")
				self.exit()
		
		#try:
		if True:
			if (action.getId() in ACTION_CONTEXT):
				self.showContextMenu()
			
			if action.getId() in ACTION_MOVEMENT_ALL:
				self.CurrentListPosition=self.getCurrentListPosition()
				self.setINFO()
				#try:uptime=eval(__settings__.getSetting("uptime"))
				#except: uptime=0
				delta=time.time()-self.uptime
				if delta > 55: 
					self.updateEPG()
					#__settings__.setSetting("uptime", repr(time.time()))
			if(action.getId() == 13):# stop
				#self.showList()
				self.setPlayed('0')
			if(action.getId() == 11):# info
				if self.selectedControlId == 600:
					list1=self.getControl(600)
					listitem = list1.getSelectedItem()
					curl = listitem.getProperty('arhive')
					id   = listitem.getProperty('id')
					if curl!='': 
						__settings__.setSetting("arhive_cnl", curl)
						__settings__.setSetting("arhive_cnl_id", id)
						self.run_arhive()#xbmc.executebuiltin('ActivateWindow(10025,"'+curl+'", return)')
		if xbmc.Player().isPlaying()==False: self.setPlayed('0')
		#except:
		#	print ("onAction: ERR")


	def onClick(self, controlID):
		print ('onClick ' +str(controlID))
		try:
			if controlID == 600:
				id = self.get_cnl_id()
				if id=='': self.exit()
				else: 
					__settings__.setSetting("v_id", id)
					if __settings__.getSetting("xplay")=='false':
						pztv.play(id)
					else:
						#self.run_starter()
						self.run_VFS()
						
						#skin = "Default"
						#self.wfs_visible=True
						#vfs = VFS_XML("PTV-VideoFullScreen.xml", addon.getAddonInfo('path'), skin, "720p")
						#create_thread({'obj':vfs})
						#vfs.doModal()
						#del vfs
						self.wfs_visible=False
					
					#self.showList()
					self.setPlayed()
					
			if controlID == 800:
				list=self.getControl(controlID)
				clp=list.getSelectedPosition()
				listitem=list.getSelectedItem()
				SG=listitem.getLabel()
				if 'COLOR' in SG: SG=pztv.get_access_gr(SG)
				if 'COLOR' not in SG:__settings__.setSetting("Sel_gr",SG)
				self.CurrentListPosition=0
				self.showList()
				list.selectItem(clp)
			if controlID == 5:
				__settings__.openSettings()
				self.showList()
			if controlID == 1:
				abc=__settings__.getSetting("abc")
				btn=self.getControl(controlID)
				if abc == 'true':
					__settings__.setSetting("abc", 'false')
					btn.setLabel('Порядок: Свой')
				else:
					__settings__.setSetting("abc", 'true')
					btn.setLabel('Порядок: ABC')
				self.showList()
		except:
			print ("onClick: ERR")

	def onFocus(self, controlID):
		self.setINFO()
		self.selectedControlId = controlID
		
		if controlID == 6: 
			list=self.getControl(800)
			self.setFocusId(800)
			list.selectItem(list.size()-1)
			
		#print controlID
		pass

	def exit(self):
		if pztv.get_autoexit_gr(): __settings__.setSetting("Sel_gr", 'Все каналы')
		self.epg_exit=True
		log("PTV exit")
		self.close()
	
	def get_cnl_id(self):
			list1=self.getControl(600)
			#n = self.getCurrentListPosition()
			listitem = list1.getSelectedItem()#list1.getListItem(n)
			id = listitem.getProperty('id')
			return id
	
	def getCurrentListPosition(self):
		list1=self.getControl(600)
		n=list1.getSelectedPosition()
		return n
	
	def setCurrentListPosition(self, n):
		list1=self.getControl(600)
		list1.selectItem(n)
	
	def set_cnl_epg(self, cid1):
		D=eval_u(pztv.SEND('epg/dict'))
		D2={}
		D2['- НЕ СВЯЗАН']='000000'
		for id in D.keys():
			try:
				title=D[id]['title']
				D2[title]=id
			except: pass
		
		L=D2.keys()
		L.sort()
		sel = xbmcgui.Dialog()
		r = sel.select("Выберите программу передач:", L)
		if r>-1:
			nm=L[r]
			cid2=D2[nm]
			#print cid2+' to '+cid1
			pztv.SEND('epg/'+cid1+'/set/'+cid2)
		update_list_epg()
		self.updateEPG()

	def showContextMenu(self):
		clp=self.getCurrentListPosition()
		controlID=self.selectedControlId
		print ('showContextMenu '+ str(controlID))
		if controlID == 600:
			id = self.get_cnl_id()
			if __settings__.getSetting("abc")=='true': 
				  context=['Добавить в группу','Удалить из группы','Объеденить с каналом', 'Разделить канал','Переименовать канал', 'Отключить канал', 'Установить EPG']
			else: context=['Добавить в группу','Удалить из группы','Переместить в группе','Объеденить с каналом', 'Разделить канал','Переименовать канал', 'Отключить канал', 'Установить EPG']
			if id in Arhive: context.append('Архив')
			
			sel = xbmcgui.Dialog()
			r = sel.select("", context)
			if r>=0:
				func=context[r]
				if   func=='Добавить в группу':    pztv.add_to_gr(id)
				elif func=='Удалить из группы':    pztv.rem_from_gr(id)
				elif func=='Переместить в группе': pztv.set_num_cn(id)
				elif func=='Объеденить с каналом': pztv.append_cnl(id)
				elif func=='Разделить канал':      pztv.split_cnl(id)
				elif func=='Переименовать канал':  pztv.rename_cnl(id)
				elif func=='Отключить канал':      pztv.remove_cnl(id)
				elif func=='Установить EPG':       self.set_cnl_epg(id)
				elif func=='Установить логотип':   self.context_picon()
				elif func=='Архив':                self.context_arhive()
				
				if   func!='Добавить в группу': self.showList()
		if controlID == 800:
			context1=['Создать группу','Удалить группу','Переместить группу','Переименовать группу', 'Объединить с группой','Установить пароль','Обновить телепрограмму']
			context2=['Создать группу','Переместить группу','Обновить телепрограмму']#,'Снять пароль'
			list2=self.getControl(800)
			listitem=list2.getSelectedItem()
			label=listitem.getLabel()
			if 'COLOR' in label:
				label=label.replace('[COLOR 44FFFFFF]','').replace('[/COLOR]','')
				context=context2
			else:
				context=context1
			sel = xbmcgui.Dialog()
			r = sel.select("", context)
			if r>=0:
				func=context[r]
				
				if   func=='Создать группу':       pztv.add_gr()
				elif func=='Удалить группу':       pztv.rem_gr(label)
				elif func=='Переместить группу':   pztv.move_gr(label)
				elif func=='Переименовать группу': pztv.rename_gr(label)
				elif func=='Объединить с группой': pztv.extend_gr(label)
				elif func=='Установить пароль':    pztv.set_pass_gr(label)
				elif func=='Снять пароль':         pztv.rem_pass_gr(label)
				elif func=='Редактор каналов':     self.run_editor()
				elif func=='Обновить каналы':      pztv.update_cnl()
				elif func=='Найти канал':          pztv.get_outbase()
				elif func=='Обновить телепрограмму': pztv.SEND('epg/refresh')

				if label == __settings__.getSetting("Sel_gr"): __settings__.setSetting("Sel_gr", 'Все каналы')
				self.showList()
		self.setCurrentListPosition(clp)

	def context_arhive(self):
				list1=self.getControl(600)
				listitem = list1.getSelectedItem()
				id = listitem.getProperty('id')
				curl = listitem.getProperty('arhive')
				if curl!='': 
					__settings__.setSetting("arhive_cnl", curl)
					__settings__.setSetting("arhive_cnl_id", id)
					self.run_arhive()

	def context_picon(self):
				list1=self.getControl(600)
				listitem = list1.getSelectedItem()
				title = listitem.getLabel() 
				id = listitem.getProperty('id')
				__settings__.setSetting("picon_cnl", title)
				__settings__.setSetting("picon_id", id)
				self.run_picon()


	def setINFO(self):
			list1=self.getControl(600)
			item=list1.getSelectedItem()
			win = xbmcgui.Window (xbmcgui.getCurrentWindowId())
			try:
					win.setProperty('EPG2_time',  item.getProperty('EPG2_time'))
					win.setProperty('EPG2_title', item.getProperty('EPG2_title'))
					win.setProperty('EPG1_time',  item.getProperty('EPG1_time'))
					win.setProperty('EPG1_title', item.getProperty('EPG1_title'))
					win.setProperty('EPG0_title', item.getProperty('EPG0_title'))
					win.setProperty('EPG0_time',  item.getProperty('EPG0_time'))
					if xbmc.Player().isPlaying(): win.setProperty('EPG0_img', '')
					else:                         win.setProperty('EPG0_img',   item.getProperty('EPG0_img'))
					win.setProperty('EPG0_plot',  item.getProperty('EPG0_plot'))
					
					if item.getProperty('EPG0_time')!='': win.setProperty('EPG_pr', 'rcb-ScrollBarH_bar.png')
					else:                                 win.setProperty('EPG_pr', 'false')
					for i in range(0,11):
						if item.getProperty('EPG_pr'+str(i*10)) == 'true': win.setProperty('EPG_pr'+str(i*10), 'rcb-ScrollBarH_bar_focus.png')
						else:                                              win.setProperty('EPG_pr'+str(i*10), 'false')
						#win.setProperty('EPG_pr'+str(i*10), 'true')
			except:
				print ('=========== set_info ERRRRRRRRRRRRRRR ==========')


	def set_epg(self, item):
		self.uptime=time.time()
		id=item.getProperty('id')
		#print '===== set_epg '+id+' ====='
		#if id in Lepg:
					#lnk='http://127.0.0.1:'+epg_port+'/channels/'+id
					#print lnk
		EPG={}
		try:
			if id in current_epg.keys(): EPG=current_epg[id]#eval(pztv.getURL(lnk))
		except: 
			print ('err current_epg '+id)
		
		if EPG!={}:
					try:EPG0_time=time.ctime(eval(EPG[0]['time']))[-13:-8]
					except: EPG0_time=''
					try:EPG0_title=EPG[0]['title']
					except: EPG0_title=''
					try:EPG0_img=EPG[0]['img']
					except: EPG0_img=background
					if EPG0_img=='':EPG0_img=background
					try:EPG0_plot=EPG[0]['plot']
					except: EPG0_plot=''
					try:EPG0_type=EPG[0]['type']
					except: EPG0_type=''
					
					try:EPG1_time=time.ctime(eval(EPG[1]['time']))[-13:-8]
					except: EPG1_time=''
					try:EPG1_title=EPG[1]['title']
					except: EPG1_title=''
					
					try:EPG2_time=time.ctime(eval(EPG[2]['time']))[-13:-8]
					except: EPG2_time=''
					try:EPG2_title=EPG[2]['title']
					except: EPG2_title=''
					
		else:
					EPG0_time=''
					EPG0_title=''
					EPG0_img=background
					EPG0_plot=''
					EPG0_type=''
					EPG1_time=''
					EPG1_title=''
					EPG2_time=''
					EPG2_title=''
		
		if EPG0_time!='' and EPG1_time!='':
				t0=eval(EPG[0]['time'])
				t1=eval(EPG[1]['time'])
				tc=time.time()
				total=t1-t0
				back=tc-t0
				percent=int(back*100/total)
				for i in range(0,11):
					if i*10 <= percent < i*10+10 :  item.setProperty('EPG_pr'+str(i*10), 'true')
					else:				item.setProperty('EPG_pr'+str(i*10), 'false')
		
		if __settings__.getSetting("fanart")=='false': EPG0_img=background
		
		if __settings__.getSetting("typeart")=='true' and EPG0_img==background: 
			if EPG0_type=='':EPG0_type=get_type(EPG0_title)
			if EPG0_type!='' : EPG0_img=get_type_art(EPG0_type)
			if EPG0_img==background: EPG0_img=''#item.getProperty('picon')
		item.setProperty('EPG0_time',  EPG0_time)
		item.setProperty('EPG0_title', EPG0_title)
		item.setProperty('EPG0_img',   EPG0_img)
		item.setProperty('EPG0_plot',  EPG0_plot)#EPG0_type+"\n"+
		
		item.setProperty('EPG1_time',  EPG1_time)
		item.setProperty('EPG1_title', EPG1_title)
		item.setProperty('EPG2_time',  EPG2_time)
		item.setProperty('EPG2_title', EPG2_title)
		#self.setINFO()
		#return item
	
	def showList(self):
		#Каналы
		#print '== showList start'
		L=pztv.root(__settings__.getSetting("Sel_gr"))
		#try: 
		#except: L=[]
		list1=self.getControl(600)
		#pos =  self.getCurrentListPosition()
		
		if xbmc.Player().isPlaying(): last_id =__settings__.getSetting("cplayed")
		else: last_id ='0'
		n=0
		#pos_set=True
		#print '== showList 4'
		picon_background = os.path.join(addon.getAddonInfo('path'), 'background.png')#xt()'http://127.0.0.1:8185/logo/background.png'
		Litm=[]
		for i in L:
			try:
				title=i['title']
				id = i['id']
				item = xbmcgui.ListItem(title)
				#item.setProperty('background', background)
				item.setProperty('id', id)
				
				if __settings__.getSetting("intlogo")=='true':
					item.setProperty('picon', i['picon'])
					item.setProperty('picon_background', picon_background)
				self.set_epg(item)
				Litm.append(item)
				#list1.addItem(item)
				
				if last_id == id:
					self.CurrentListPosition=n
					if xbmc.Player().isPlaying(): item.setLabel2(title)
				n+=1
			except: pass
		list1.reset()
		list1.addItems(Litm)
		
		#print '== showList 5'
		self.setCurrentListPosition(self.CurrentListPosition)
		#self.setPlayed()
		if __settings__.getSetting("arhon")=='true': self.setArhive()
		
		#Группы
		self.getControl(95).setLabel('Группа: '+__settings__.getSetting("Sel_gr"))
		list2=self.getControl(800)
		list2.reset()
		try:Lgr=pztv.select_gr('', True)
		except: Lgr=[]
		n=0
		for i in Lgr:
				item = xbmcgui.ListItem(str(i))
				list2.addItem(item)
		
		if len(L)>0:     self.setFocus(self.getControl(600))
		elif len(Lgr)>0: self.setFocus(self.getControl(800))
		else:            self.setFocus(self.getControl(5))
		
		#print '== showList 6'
		#if len(L)>0: self.updateEPG()
		#print '== showList end'
	
	def setPlayed(self, last_id =''):
			if last_id =='':
				if xbmc.Player().isPlaying(): last_id =__settings__.getSetting("cplayed")
				else: last_id ='0'
			list1=self.getControl(600)
			try:n=list1.size()
			except: return
			for i in range(n):
				try:
					item = list1.getListItem(i)
					if last_id == item.getProperty('id'): item.setLabel2(item.getLabel())
					else: item.setLabel2('')
				except:
					pass
	
	def setArhive(self):
			list1=self.getControl(600)
			try:n=list1.size()
			except: return
			for i in range(n):
				item = list1.getListItem(i)
				id = item.getProperty('id')
				if id in Arhive: 
					arh=id
				else: 
					arh=""
				item.setProperty('arhive', arh)
				if arh == '': item.setProperty('arhive_visible', 'false')
				else:        item.setProperty('arhive_visible', 'true')


	def updateEPG(self):
		list1=self.getControl(600)
		if __settings__.getSetting("epgon")=='true':
			#for i in range(list1.size()):
			#	try:
			#		item = list1.getListItem(i)
			#		self.set_epg(item)
			#	except: pass
			
			update_current_epg()
			
			try:n=list1.size()
			except: return
			for i in range(n):
				try:
					item = list1.getListItem(i)
					self.set_epg(item)
				except: 
					#self.close()
					print ('ERR: Ошибка назначения EPG элементу '+str(i))
		else:
			try:n=list1.size()
			except: return
			for i in range(0, n):
				try:
					item = list1.getListItem(i)
					#item.setProperty('EPG0_title', item.getLabel())
					item.setProperty('EPG0_img',background)#item.getProperty('picon')
				except: 
					print ('ERR: Ошибка назначения EPG элементу '+str(i))
	
	def run_editor(self):
				#skin = "Default"
				editor = EDITOR_XML("PTV-EDITOR.xml", addon.getAddonInfo('path'), skin, "720p")
				editor.doModal()
				del editor

	def run_arhive(self):
				#skin = "Default"
				arhive = ARHIVE_XML("PTV-arhive.xml", addon.getAddonInfo('path'), skin, "720p")
				arhive.doModal()
				del arhive
	def run_picon(self):
				return
				#skin = "Default"
				picon = PICON_XML("PTV-picon.xml", addon.getAddonInfo('path'), skin, "720p")
				picon.doModal()
				del picon

	def epg_loop(self, pos=0):
		if self.wfs_visible==False:
			try:self.updateEPG()
			except: print ('ERR LOOP EPG')
		for i in range(5):
			if self.epg_exit==True: return
			time.sleep(1)
		#print (pos)
		self.epg_loop(pos+1)
	
	def run_starter(self):
				xbmc.Player().stop()
				__settings__.setSetting("n_play", '0')
				sts = STARTER_XML("PTV-starter.xml", addon.getAddonInfo('path'), skin, "720p")
				sts.doModal()
				del sts
	
	def run_VFS(self):
			self.wfs_visible=True
			vfs = VFS_XML("PTV-VideoFullScreen.xml", addon.getAddonInfo('path'), skin, "720p")
			create_thread({'obj':vfs})
			vfs.doModal()
			del vfs

class LIST_XML(xbmcgui.WindowXMLDialog):#
	selectedControlId = 0
	def __init__(self,strXMLname, strFallbackPath, strDefaultName, forceFallback):
		self.CurrentListPosition=0
		self.uptime=0
		self.uparh=0
		#if __settings__.getSetting("arhon")=='true': update_Arhive()
		pass

	def onInit(self):
		try:
			# Put your List Populating code/ and GUI startup stuff here
			self.setFocus(self.getControl(CONTROL_GAMES_GROUP_START))
			#self.clearList()
			
			self.showList()
			
			#abc=__settings__.getSetting("abc")
			#btn=self.getControl(1)
			#if abc == 'false':	btn.setLabel('Порядок: Свой')
			#else:				btn.setLabel('Порядок: ABC')
			
			#if __settings__.getSetting("arhon")=='true' and self.uparh==0:
			#	update_Arhive()
			#	self.uparh=1
			#	self.setArhive()
		except:
			pass


	def onAction(self, action):
		log("onAction: "+ str(action.getId()))
		# Same as normal python Windows.
		if(action.getId() == 0):
			log("actionId == 0. Input ignored")
			return
		
		if(action.getId() in ACTION_CANCEL_DIALOG):
				log("onAction: ACTION_CANCEL_DIALOG")
				self.exit()
		
		try:
			if (action.getId() in ACTION_CONTEXT):
				self.showContextMenu()
			
			if action.getId() in ACTION_MOVEMENT_ALL:
				self.CurrentListPosition=self.getCurrentListPosition()
				#self.setINFO()
				#try:uptime=eval(__settings__.getSetting("uptime"))
				#except: uptime=0
				#delta=time.time()-self.uptime
				#if delta > 55: 
				#	self.updateEPG()
					#__settings__.setSetting("uptime", repr(time.time()))
			if(action.getId() == 13):# stop
				#self.showList()
				#self.setPlayed()
				self.exit()
		except:
			print ("onAction: ERR")


	def onClick(self, controlID):
		print ('onClick ' +str(controlID))
		try:
			if controlID == 600:
				id = self.get_cnl_id()
				if id=='': self.exit()
				else: 
					__settings__.setSetting("v_id", id)
					#xbmc.sleep(100)
					#if __settings__.getSetting("xplay")=='false':
					#pztv.play(id)
					#self.close()
					self.exit()
					#xbmc.Player().stop()
					#xbmc.sleep(100)
					
					#playlist = pztv.play(id)
					#pztv.Player.play(playlist, windowed=True)
					
					self.run_starter()
					#else:
						#vfs = VFS_XML("PTV-VideoFullScreen.xml", addon.getAddonInfo('path'), skin, "720p")
						#vfs.doModal()
						#del vfs
					
					
					#self.setPlayed()
					
			if controlID == 800:
				list=self.getControl(controlID)
				clp=list.getSelectedPosition()
				listitem=list.getSelectedItem()
				SG=listitem.getLabel()
				if 'COLOR' in SG: SG=pztv.get_access_gr(SG)
				if 'COLOR' not in SG:__settings__.setSetting("Sel_gr",SG)
				self.CurrentListPosition=0
				self.showList()
				list.selectItem(clp)
			if controlID == 5:
				__settings__.openSettings()
				self.showList()
			if controlID == 1:
				abc=__settings__.getSetting("abc")
				btn=self.getControl(controlID)
				if abc == 'true':
					__settings__.setSetting("abc", 'false')
					btn.setLabel('Порядок: Свой')
				else:
					__settings__.setSetting("abc", 'true')
					btn.setLabel('Порядок: ABC')
				self.showList()
		except:
			print ("onClick: ERR")

	def onFocus(self, controlID):
		#print controlID
		self.setINFO()
		self.selectedControlId = controlID
		if controlID == 6: 
			list=self.getControl(800)
			self.setFocusId(800)
			list.selectItem(list.size()-1)
		
		if controlID == 61:
			self.exit()

	def exit(self):
		if pztv.get_autoexit_gr(): __settings__.setSetting("Sel_gr", 'Все каналы')
		log("PTV exit")
		self.close()
	
	def get_cnl_id(self):
			list1=self.getControl(600)
			#n = self.getCurrentListPosition()
			listitem = list1.getSelectedItem()#list1.getListItem(n)
			id = listitem.getProperty('id')
			return id
	
	def getCurrentListPosition(self):
		list1=self.getControl(600)
		n=list1.getSelectedPosition()
		return n
	
	def setCurrentListPosition(self, n):
		list1=self.getControl(600)
		list1.selectItem(n)
	
	def set_cnl_epg(self, cid1):
		D=eval_u(pztv.SEND('epg/dict'))
		D2={}
		D2['- НЕ СВЯЗАН']='000000'
		for id in D.keys():
			try:
				title=D[id]['title']
				D2[title]=id
			except: pass
		
		L=D2.keys()
		L.sort()
		sel = xbmcgui.Dialog()
		r = sel.select("Выберите программу передач:", L)
		if r>-1:
			nm=L[r]
			cid2=D2[nm]
			#print cid2+' to '+cid1
			pztv.SEND('epg/'+cid1+'/set/'+cid2)
		update_list_epg()
		self.updateEPG()

	def showContextMenu(self):
		clp=self.getCurrentListPosition()
		controlID=self.selectedControlId
		print ('showContextMenu '+ str(controlID))
		if controlID == 600:
			id = self.get_cnl_id()
			if __settings__.getSetting("abc")=='true': 
				  context=['Добавить в группу','Удалить из группы','Объеденить с каналом', 'Разделить канал','Переименовать канал', 'Отключить канал', 'Установить EPG']
			else: context=['Добавить в группу','Удалить из группы','Переместить в группе','Объеденить с каналом', 'Разделить канал','Переименовать канал', 'Отключить канал', 'Установить EPG']
			if id in Arhive: context.append('Архив')
			
			sel = xbmcgui.Dialog()
			r = sel.select("", context)
			if r>=0:
				func=context[r]
				if   func=='Добавить в группу':    pztv.add_to_gr(id)
				elif func=='Удалить из группы':    pztv.rem_from_gr(id)
				elif func=='Переместить в группе': pztv.set_num_cn(id)
				elif func=='Объеденить с каналом': pztv.append_cnl(id)
				elif func=='Разделить канал':      pztv.split_cnl(id)
				elif func=='Переименовать канал':  pztv.rename_cnl(id)
				elif func=='Отключить канал':      pztv.remove_cnl(id)
				elif func=='Установить EPG':       self.set_cnl_epg(id)
				elif func=='Установить логотип':   self.context_picon()
				elif func=='Архив':                self.context_arhive()
				
				if   func!='Добавить в группу': self.showList()
		if controlID == 800:
			context1=['Создать группу','Удалить группу','Переместить группу','Переименовать группу', 'Объединить с группой','Установить пароль','Обновить телепрограмму']
			context2=['Создать группу','Переместить группу','Обновить телепрограмму']#,'Снять пароль'
			list2=self.getControl(800)
			listitem=list2.getSelectedItem()
			label=listitem.getLabel()
			if 'COLOR' in label:
				label=label.replace('[COLOR 44FFFFFF]','').replace('[/COLOR]','')
				context=context2
			else:
				context=context1
			sel = xbmcgui.Dialog()
			r = sel.select("", context)
			if r>=0:
				func=context[r]
				
				if   func=='Создать группу':       pztv.add_gr()
				elif func=='Удалить группу':       pztv.rem_gr(label)
				elif func=='Переместить группу':   pztv.move_gr(label)
				elif func=='Переименовать группу': pztv.rename_gr(label)
				elif func=='Объединить с группой': pztv.extend_gr(label)
				elif func=='Установить пароль':    pztv.set_pass_gr(label)
				elif func=='Снять пароль':         pztv.rem_pass_gr(label)
				elif func=='Редактор каналов':     self.run_editor()
				elif func=='Обновить каналы':      pztv.update_cnl()
				elif func=='Найти канал':          pztv.get_outbase()
				elif func=='Обновить телепрограмму': pztv.SEND('epg/refresh')

				if label == __settings__.getSetting("Sel_gr"): __settings__.setSetting("Sel_gr", 'Все каналы')
				self.showList()
		self.setCurrentListPosition(clp)

	def context_arhive(self):
				list1=self.getControl(600)
				listitem = list1.getSelectedItem()
				id = listitem.getProperty('id')
				curl = listitem.getProperty('arhive')
				if curl!='': 
					__settings__.setSetting("arhive_cnl", curl)
					__settings__.setSetting("arhive_cnl_id", id)
					self.run_arhive()

	def context_picon(self):
				list1=self.getControl(600)
				listitem = list1.getSelectedItem()
				title = listitem.getLabel() 
				id = listitem.getProperty('id')
				__settings__.setSetting("picon_cnl", title)
				__settings__.setSetting("picon_id", id)
				self.run_picon()


	def setINFO(self):
			list1=self.getControl(600)
			item=list1.getSelectedItem()
			win = xbmcgui.Window (xbmcgui.getCurrentWindowId())
			try:
					win.setProperty('EPG2_time',  item.getProperty('EPG2_time'))
					win.setProperty('EPG2_title', item.getProperty('EPG2_title'))
					win.setProperty('EPG1_time',  item.getProperty('EPG1_time'))
					win.setProperty('EPG1_title', item.getProperty('EPG1_title'))
					win.setProperty('EPG0_title', item.getProperty('EPG0_title'))
					win.setProperty('EPG0_time',  item.getProperty('EPG0_time'))
					if xbmc.Player().isPlaying(): win.setProperty('EPG0_img', '')
					else:                         win.setProperty('EPG0_img',   item.getProperty('EPG0_img'))
					win.setProperty('EPG0_plot',  item.getProperty('EPG0_plot'))
					
					if item.getProperty('EPG0_time')!='': win.setProperty('EPG_pr', 'rcb-ScrollBarH_bar.png')
					else:                                 win.setProperty('EPG_pr', 'false')
					for i in range(0,11):
						if item.getProperty('EPG_pr'+str(i*10)) == 'true': win.setProperty('EPG_pr'+str(i*10), 'rcb-ScrollBarH_bar_focus.png')
						else:                                              win.setProperty('EPG_pr'+str(i*10), 'false')
						#win.setProperty('EPG_pr'+str(i*10), 'true')
			except:
				print ('=========== set_info ERRRRRRRRRRRRRRR ==========')


	def set_epg(self, item):
		self.uptime=time.time()
		id=item.getProperty('id')
		#print '===== set_epg '+id+' ====='
		#if id in Lepg:
					#lnk='http://127.0.0.1:'+epg_port+'/channels/'+id
					#print lnk
		EPG={}
		try:
			if id in current_epg.keys(): EPG=current_epg[id]#eval(pztv.getURL(lnk))
		except: 
			print ('err current_epg '+id)
		
		if EPG!={}:
					try:EPG0_time=time.ctime(eval(EPG[0]['time']))[-13:-8]
					except: EPG0_time=''
					try:EPG0_title=EPG[0]['title']
					except: EPG0_title=''
					try:EPG0_img=EPG[0]['img']
					except: EPG0_img=background
					if EPG0_img=='':EPG0_img=background
					try:EPG0_plot=EPG[0]['plot']
					except: EPG0_plot=''
					try:EPG0_type=EPG[0]['type']
					except: EPG0_type=''
					
					try:EPG1_time=time.ctime(eval(EPG[1]['time']))[-13:-8]
					except: EPG1_time=''
					try:EPG1_title=EPG[1]['title']
					except: EPG1_title=''
					
					try:EPG2_time=time.ctime(eval(EPG[2]['time']))[-13:-8]
					except: EPG2_time=''
					try:EPG2_title=EPG[2]['title']
					except: EPG2_title=''
					
		else:
					EPG0_time=''
					EPG0_title=''
					EPG0_img=background
					EPG0_plot=''
					EPG0_type=''
					EPG1_time=''
					EPG1_title=''
					EPG2_time=''
					EPG2_title=''
		
		if EPG0_time!='' and EPG1_time!='':
				t0=eval(EPG[0]['time'])
				t1=eval(EPG[1]['time'])
				tc=time.time()
				total=t1-t0
				back=tc-t0
				percent=int(back*100/total)
				for i in range(0,11):
					if i*10 <= percent < i*10+10 :  item.setProperty('EPG_pr'+str(i*10), 'true')
					else:				item.setProperty('EPG_pr'+str(i*10), 'false')
		
		if __settings__.getSetting("fanart")=='false': EPG0_img=background
		
		if __settings__.getSetting("typeart")=='true' and EPG0_img==background: 
			if EPG0_type=='': EPG0_type=get_type(EPG0_title)
			if EPG0_type!='': EPG0_img=get_type_art(EPG0_type)
			if EPG0_img==background: EPG0_img=''#item.getProperty('picon')
		
		item.setProperty('EPG0_time',  EPG0_time)
		item.setProperty('EPG0_title', EPG0_title)
		item.setProperty('EPG0_img',   EPG0_img)
		item.setProperty('EPG0_plot',  EPG0_plot)#EPG0_type+"\n"+
		
		item.setProperty('EPG1_time',  EPG1_time)
		item.setProperty('EPG1_title', EPG1_title)
		item.setProperty('EPG2_time',  EPG2_time)
		item.setProperty('EPG2_title', EPG2_title)
		#self.setINFO()
		#return item
		
	def showList(self):
		#Каналы
		#print '== showList start'
		try:L=pztv.root(__settings__.getSetting("Sel_gr"))
		except: L=[]
		list1=self.getControl(600)
		#pos =  self.getCurrentListPosition()
		#list1.reset()
		if xbmc.Player().isPlaying(): last_id =__settings__.getSetting("cplayed")
		else: last_id ='0'
		n=0
		#pos_set=True
		#print '== showList 4'
		picon_background = os.path.join(addon.getAddonInfo('path'), 'background.png')#xt()'http://127.0.0.1:8185/logo/background.png'
		Litm=[]
		for i in L:
			try:
				title=i['title']
				id = i['id']
				item = xbmcgui.ListItem(title)
				#item.setProperty('background', background)
				item.setProperty('id', id)
				
				if __settings__.getSetting("intlogo")=='true':
					item.setProperty('picon', i['picon'])
					item.setProperty('picon_background', picon_background)
				#self.set_epg(item)
				Litm.append(item)
				#list1.addItem(item)
				
				if last_id == id:
					self.CurrentListPosition=n
					if xbmc.Player().isPlaying(): item.setLabel2(title)
				n+=1
			except: pass
		list1.reset()
		list1.addItems(Litm)
		
		#print '== showList 5'
		self.setCurrentListPosition(self.CurrentListPosition)
		
		#self.setPlayed()
		#if __settings__.getSetting("arhon")=='true': self.setArhive()
		
		#Группы
		self.getControl(95).setLabel('Группа: '+__settings__.getSetting("Sel_gr"))
		list2=self.getControl(800)
		list2.reset()
		try:Lgr=pztv.select_gr('', True)
		except: Lgr=[]
		n=0
		for i in Lgr:
				item = xbmcgui.ListItem(str(i))
				list2.addItem(item)
		
		if len(L)>0:     self.setFocus(self.getControl(600))
		elif len(Lgr)>0: self.setFocus(self.getControl(800))
		else:            self.setFocus(self.getControl(5))
		#print '== showList 6'
		if len(L)>0: self.updateEPG()
		#print '== showList end'
	
	def setPlayed(self):
			if xbmc.Player().isPlaying(): 
				last_id =__settings__.getSetting("cplayed")
				list1=self.getControl(600)
				try: n=list1.size()
				except: return
				for i in range(n):
					try:
						item = list1.getListItem(i)
						if last_id == item.getProperty('id'): item.setLabel2(item.getLabel())
						else: item.setLabel2('')
					except:
						pass
	
	def setArhive(self):
			list1=self.getControl(600)
			try:n=list1.size()
			except: return
			for i in range(0, n):
				item = list1.getListItem(i)
				id = item.getProperty('id')
				if id in Arhive: 
					arh=id
				else: 
					arh=""
				item.setProperty('arhive', arh)
				if arh == '': item.setProperty('arhive_visible', 'false')
				else:        item.setProperty('arhive_visible', 'true')


	def updateEPG(self):
		list1=self.getControl(600)
		if __settings__.getSetting("epgon")=='true':
			#for i in range(0, list1.size()):
			#	try:
			#		item = list1.getListItem(i)
			#		self.set_epg(item)
			#	except: pass
			
			
			try:n=list1.size()
			except: return
			for i in range(0, n):
				try:
					item = list1.getListItem(i)
					self.set_epg(item)
				except: 
					#self.close()
					print ('ERR: Ошибка назначения EPG элементу '+str(i))
			update_current_epg()
			
		else:
			try:n=list1.size()
			except: return
			for i in range(0, n):
				try:
					item = list1.getListItem(i)
					#item.setProperty('EPG0_title', item.getLabel())
					item.setProperty('EPG0_img',background)#item.getProperty('picon')
				except: 
					print ('ERR: Ошибка назначения EPG элементу '+str(i))
	
	def run_editor(self):
				#skin = "Default"
				editor = EDITOR_XML("PTV-EDITOR.xml", addon.getAddonInfo('path'), skin, "720p")
				editor.doModal()
				del editor

	def run_arhive(self):
				#skin = "Default"
				arhive = ARHIVE_XML("PTV-arhive.xml", addon.getAddonInfo('path'), skin, "720p")
				arhive.doModal()
				del arhive
	def run_picon(self):
				return
				#skin = "Default"
				picon = PICON_XML("PTV-picon.xml", addon.getAddonInfo('path'), skin, "720p")
				picon.doModal()
				del picon
	def run_starter(self):
				xbmc.Player().stop()
				__settings__.setSetting("n_play", '0')
				sts = STARTER_XML("PTV-starter.xml", addon.getAddonInfo('path'), skin, "720p")
				sts.doModal()
				del sts

class EDITOR_XML(xbmcgui.WindowXML):
	def __init__(self,strXMLname, strFallbackPath, strDefaultName, forceFallback):
		pass
	
	def onInit(self):
		self.showList()
		self.setFocus(self.getControl(500))


	def showList(self):
		#Группы
		
		SG=pztv.get_SG()
		list1=self.getControl(500)
		list1.reset()
		Lgr=pztv.select_gr('', True)
		for i in Lgr:
				item = xbmcgui.ListItem(str(i))
				if SG==str(i): item.setLabel2(str(i))
				else:item.setLabel2('')
				list1.addItem(item)

		# Все каналы
		CL=pztv.get_gr()
		list2=self.getControl(600)
		list2.reset()
		if pztv.get_autoexit_gr(): pas=False
		else: pas=True
		Lcn=pztv.get_gr('Все каналы', pas)
		for i in Lcn:
				title=pztv.DBC[i]['title']
				item = xbmcgui.ListItem(title)
				if i in CL: item.setLabel2(title)
				else:item.setLabel2('')
				item.setProperty('id', i)
				list2.addItem(item)

		list3=self.getControl(700)
		list3.reset()
		Lcn=pztv.get_gr()
		for i in Lcn:
			
				try:title=pztv.DBC[i]['title']
				except: title=i
				item = xbmcgui.ListItem(title)
				item.setProperty('id', i)
				list3.addItem(item)


	def color500(self):
		SG=pztv.get_SG()
		list1=self.getControl(500)
		Lgr=pztv.select_gr('', True)
		n=0
		for i in Lgr:
				item=list1.getListItem(n)
				if SG==str(i): item.setLabel2(str(i))
				else:item.setLabel2('')
				n+=1

	def color600(self):
		CL=pztv.get_gr()
		list2=self.getControl(600)
		if pztv.get_autoexit_gr(): pas=False
		else: pas=True
		Lcn=pztv.get_gr('Все каналы', pas)
		n=0
		for i in Lcn:
				title=pztv.DBC[i]['title']
				item=list2.getListItem(n)
				if i in CL: item.setLabel2(title)
				else:item.setLabel2('')
				n+=1

	def reset600(self):
		CL=pztv.get_gr()
		list2=self.getControl(600)
		list2.reset()
		if pztv.get_autoexit_gr(): pas=False
		else: pas=True
		Lcn=pztv.get_gr('Все каналы', pas)
		for i in Lcn:
				title=pztv.DBC[i]['title']
				item = xbmcgui.ListItem(title)
				if i in CL: item.setLabel2(title)
				else:item.setLabel2('')
				item.setProperty('id', i)
				list2.addItem(item)



	def reset700(self):
		list3=self.getControl(700)
		list3.reset()
		Lcn=pztv.get_gr()
		for i in Lcn:
				try:title=pztv.DBC[i]['title']
				except: title=i
				item = xbmcgui.ListItem(title)
				item.setProperty('id', i)
				list3.addItem(item)


	def onClick(self, controlID):
		print ('onClick ' +str(controlID))
				
		if controlID == 500:
			list=self.getControl(controlID)
			listitem=list.getSelectedItem()
			SG=listitem.getLabel()
			if 'COLOR' in SG: SG=pztv.get_access_gr(SG)
			if 'COLOR' not in SG:
				__settings__.setSetting("Sel_gr",SG)
			self.color500()
			self.reset600()
			self.reset700()
		
		if controlID == 600:
			list=self.getControl(controlID)
			listitem=list.getSelectedItem()
			id=listitem.getProperty('id')
			if listitem.getLabel2()=='': pztv.add_to_gr(id, pztv.get_SG())
			else: pztv.rem_from_gr(id)
			self.color500()
			self.color600()
			self.reset700()
		
		if controlID == 700:
			list=self.getControl(controlID)
			listitem=list.getSelectedItem()
			id=listitem.getProperty('id')
			pztv.rem_from_gr(id)
			list.removeItem(list.getSelectedPosition())
			self.color600()

		if controlID == 5:
			__settings__.openSettings()
			self.showList()

class ARHIVE_XML(xbmcgui.WindowXML):
	def __init__(self,strXMLname, strFallbackPath, strDefaultName, forceFallback):
		self.dir=__settings__.getSetting("arhive_cnl")
		self.cid=__settings__.getSetting("arhive_cnl_id")
		try: self.epg=eval_u(pztv.getURL('http://127.0.0.1:'+epg_port+'/channel/full/id='+str(self.cid)))
		except: self.epg={}
		pztv.set_arhive_date(0)
	
	def onInit(self):
		self.showList()
		self.setFocus(self.getControl(600))
	
	def showList(self):
		win = xbmcgui.Window (xbmcgui.getCurrentWindowId())
		
		try:
			inf = eval_u(pztv.SEND('/channel/'+self.cid+'/inf'))
			ctitle  = inf['title']
			picon = inf['picon']
		except:
			picon = ''#pztv.get_picon(self.cid)
			ctitle = ''#pztv.DBC[self.cid]['title']
		arhive_date = pztv.get_arhive_date()
		win.setProperty('update', 'update.gif')
		win.setProperty('picon',  picon)
		win.setProperty('picon_background', os.path.join(os.path.split(picon)[0], 'background.png'))
		win.setProperty('title',  ctitle)
		win.setProperty('date',  arhive_date)
		#даты
		list1=self.getControl(500)
		list1.reset()
		for i in range (0,10):
			ssec=i*24*60*60
			t=time.localtime(time.time() - ssec)
			st=time.strftime('%d.%m.%Y',t)
			item = xbmcgui.ListItem(st)
			if st == arhive_date: item.setLabel2(st)
			list1.addItem(item)
		
		# передачи
		list2=self.getControl(600)
		list2.reset()
		L=pztv.get_arhive_canale(self.cid)
		for i in L:
			#print i['title']
			item = xbmcgui.ListItem(i['title'])
			item.setProperty('curl', i['id'])
			item.setProperty('title', i['title'])
			list2.addItem(item)
		
		if L!=[]: self.setFocus(self.getControl(600))
		else: self.setFocus(self.getControl(500))
		win.setProperty('update', '')

	def onClick(self, controlID):
		print ('onClick ' +str(controlID))
		
		if controlID == 600:
			__settings__.setSetting("cplayed",'arh')
			list=self.getControl(controlID)
			listitem=list.getSelectedItem()
			curl=listitem.getProperty('curl')
			Lpurl=pztv.get_arhive_strm(curl)
			player=xbmc.Player()
			#player.play(Lpurl[0])
			playlist = xbmc.PlayList (xbmc.PLAYLIST_VIDEO)
			playlist.clear()
			n=0
			for purl in Lpurl:
				n+=1
				title = listitem.getProperty('title')#'['+str(n)+'/'+str(len(Lpurl))+'] '+pztv.mfind(purl, "//", "/")
				item = xbmcgui.ListItem(title, path=purl)
				playlist.add(url=purl, listitem=item)
			
			player.play(playlist)
			
		if controlID == 500:
			list=self.getControl(controlID)
			r=list.getSelectedPosition()
			pztv.set_arhive_date(r)
			self.showList()

class PICON_XML(xbmcgui.WindowXML):
	def __init__(self,strXMLname, strFallbackPath, strDefaultName, forceFallback):
		self.cid=__settings__.getSetting("picon_id")
		self.cnl=__settings__.getSetting("picon_cnl")
	
	def onInit(self):
		self.showList()
		self.setFocus(self.getControl(600))
	
	def showList(self):
		
		win = xbmcgui.Window (xbmcgui.getCurrentWindowId())
		#picon = pztv.get_picon(self.cid)
		title = self.cnl
		win.setProperty('title',  title)
		# передачи
		L=pztv.get_picons(title)
		list1=self.getControl(600)
		list1.reset()
		for i in L:
				#print i
				title=i[i.rfind('/')+1:]
				item = xbmcgui.ListItem(title)
				item.setProperty('id', self.cid)
				item.setProperty('picon', i)
				list1.addItem(item)

	def onClick(self, controlID):
		print ('onClick ' +str(controlID))
		
		if controlID == 600:
			list=self.getControl(controlID)
			listitem=list.getSelectedItem()
			id=listitem.getProperty('id')
			cp=os.path.join(pztv.Logo, id+'.png')
			cover=listitem.getProperty('picon')
			try:
				import urllib2
				req = urllib2.Request(url = cover, data = None)
				req.add_header('User-Agent', 'Mozilla/4.0 (compatible; MSIE 8.0; Windows NT 5.1; Trident/4.0; Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1) ; .NET CLR 1.1.4322; .NET CLR 2.0.50727; .NET CLR 3.0.4506.2152; .NET CLR 3.5.30729; .NET4.0C)')
				resp = urllib2.urlopen(req)
				fl = open(cp, "wb")
				fl.write(resp.read())
				fl.close()
			except: pass
			self.close()


def main():
	#skin = "Default"
	ui = UI_XML("PTV-main.xml", addon.getAddonInfo('path'), skin, "720p")
	create_thread({'obj':ui})
	ui.doModal()
	del ui

Ls=["Default", "Estuary", "Glass", "Grid", "Table", "Guide"]
skin = Ls[int(__settings__.getSetting('skin'))]
L=pztv.root(__settings__.getSetting("Sel_gr"))
#xbmcplugin.endOfDirectory(handle, False, False)
main()
